---------------------------------------------------------------------------------------------------
--
-- Title       : contr_traf
-- Design      : contr_traf
-- Author      : Calazans
-- Company     : PUCRS
--
---------------------------------------------------------------------------------------------------
--
-- File        : contr_traf.vhd
-- Generated   : Mon Apr 24 18:09:41 2006
-- From        : interface description file
-- By          : Itf2Vhdl ver. 1.20
--
---------------------------------------------------------------------------------------------------
--
-- Description : 
--
---------------------------------------------------------------------------------------------------

--{{ Section below this comment is automatically maintained
--   and may be overwritten
--{entity {contr_traf} architecture {contr_traf}}

library IEEE;
use IEEE.STD_LOGIC_1164.all;



entity contr_traf is
	 port(
		 clock : in STD_LOGIC;
		 reset : in STD_LOGIC;
		 RT : in STD_LOGIC;
		 VP : in STD_LOGIC;
		 VB : out STD_LOGIC
	     );
end contr_traf;

--}} End of automatically maintained section

architecture contr_traf of contr_traf is	
type states is (a, b);
signal EA, PE : states;
begin

st_rg:	process (clock, reset)
	begin 
		if reset='1' then EA <= a;
		elsif clock'event and clock='1' then
			EA <= PE;
		end if;
	end process;
	
func_sai_trans:	process	(EA,RT,VP)
	begin 
	  	case EA is
			when a =>
				if RT='1' and VP='1' then
					PE <= b;
				else PE <= a;
				end if;
				VB <= '0';
			when others =>
				if RT='0' then
					PE <= a;
				else PE <= b;
				end if;
				VB <= '1';
		end case;

	end process;
	

end contr_traf;
